/* ***************************
 Website:  http://wch.cn
 Email:    tech@wch.cn
 Author:   W.ch 2008.7
******************************/
#include	"PIN.H"			// ޸ĸļӦӲ/Ƭͺŵ
#include	"CH454CMD.H"	// CH454
#include <INTRINS.h>

#define DELAY  { _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_(); }

void CH454_I2c_Start( void )  // ʼ
{
	DISABLE_KEY_INTERRUPT;  //ֹж,ֹʼʱCH454ж϶жϷеSTART
	CH454_SDA_SET;   /*ʼź*/
    CH454_SDA_D_OUT;   /* SDAΪ */
	DELAY;
	CH454_SCL_SET;
    CH454_SCL_D_OUT;   /* SCLΪ */
	DELAY;

	CH454_SDA_CLR;   /*ʼź*/
	DELAY;    

	CH454_SCL_CLR;   /*ǯסI2Cߣ׼ͻ */
	DELAY;
}

void CH454_I2c_Stop( void )  // 
{
	CH454_SDA_CLR;
    CH454_SDA_D_OUT;   /* SDAΪ */
	DELAY;

	CH454_SCL_SET;
	DELAY;

	CH454_SDA_SET;  /*I2C߽ź*/
	DELAY;

    CH454_SDA_D_IN;   /* SDAΪ뷽 */
    DELAY;

  	ENABLE_KEY_INTERRUPT;
}

void CH454_I2c_WrByte( UINT8 dat )	//дһֽ
{
	UINT8 i;
	CH454_SDA_D_OUT;   /* SDAΪ */
	DELAY;

	for( i = 0; i != 8; i++ )  // 8λ
	{
		if( dat & 0x80 ) 
		{
		    CH454_SDA_SET;
		}
		else 
		{
		    CH454_SDA_CLR;
		}
		DELAY;

		CH454_SCL_SET;
		dat <<= 1;
		DELAY;

		CH454_SCL_CLR;
		DELAY;
	}
	CH454_SDA_D_IN;   /* SDAΪ뷽 */
    CH454_SDA_SET;
	DELAY;

	CH454_SCL_SET;  // Ӧ
	DELAY;

	CH454_SCL_CLR;
	DELAY;
}

UINT8  CH454_I2c_RdByte( void )		//һֽ
{
	UINT8 dat,i;
    CH454_SDA_SET;
	CH454_SDA_D_IN;   /* SDAΪ뷽 */
    DELAY;

	dat = 0;
	for( i = 0; i != 8; i++ )  // 8λ
	{
		CH454_SCL_SET;
		DELAY;

		dat <<= 1;
		if( CH454_SDA_IN ) dat++;  // 1λ

		CH454_SCL_CLR;
		DELAY;
	}

	CH454_SDA_SET;
    
	DELAY;

	CH454_SCL_SET;  // ЧӦ

	DELAY;

	CH454_SCL_CLR;
	DELAY;

	return dat;
}

void ch454_write( UINT16 cmd )	//д
{
	CH454_I2c_Start();               /**/

   	CH454_I2c_WrByte((UINT8)(cmd>>7)&CH454_I2C_MASK|CH454_I2C_ADDR); 

   	CH454_I2c_WrByte((UINT8)cmd);     /**/
  	CH454_I2c_Stop();                 /**/ 
}





UINT8 CH454_Read( UINT16 read_cmd )		//ȡ
{
	UINT8 keycode;
   	CH454_I2c_Start();                /**/

	CH454_I2c_WrByte((UINT8)(read_cmd>>7)&CH454_I2C_MASK|CH454_I2C_ADDR|0x01);
	
   	keycode = CH454_I2c_RdByte();      /*ȡ*/
	CH454_I2c_Stop();                /**/ 

	return keycode;
}
